/*
 * SpoolFax.rexx
 * D. Varley, C-Born Software Systems
 * 07DEC93
 *
 * Synopsis:
 *	Example Rexx script to allow manual spooling of fax files
 *	Written in response to query from Michael Schrader-Boelsche
 *	This is just a quick demo, and could easily be jazzed up!
 *
 * Use:
 *	SpoolFax FaxFile Addressee
 *
 */
options results

/* trace results */	/* uncomment this line to debug */

/* change these as required */
from  = "786530"
resol = "Fine:"
retries = 3

address command

parse arg file user

/* do some error checking */
if file == "" then do
	say "Usage: SpoolFax faxfile addressee"
	exit(999)
end
if user == "" then do
	say "Usage: SpoolFax faxfile addressee"
	exit(999)
end

/* Get spool-file name */

sfnum = 0;
do sfnum = 0 to 1000
	sfname = "FAXSPOOL:F_"||sfnum||".SPL"
	if ~exists(sfname) then leave
	if sfnum >= 999 then do
		say "Error: Can't get spool file"
		exit(999)
	end
end

res = open('sfile', sfname, 'write')
if res ~= 1 then do
	say "Error: Can't open "||sfname
	exit(999)
end

call writeln('sfile', "From: "||from)
call writeln('sfile', "To: "||user)
call writeln('sfile', "Source: No File")
call writeln('sfile', "Fax: "||file)
call writeln('sfile', resol)
call writeln('sfile', "Retries: "||retries)

call close('sfile')

say file||" Spooled to "||user||" using Spool File "||sfname

