#ifndef CLIB_MPIMAGE_PROTOS_H
#define CLIB_MPIMAGE_PROTOS_H

/* Prototypes for MPImage.library */

/* mark@topic.demon.co.uk */
/* mpaddock@cix.compulink.co.uk */

/* $VER: MPImage_protos.h 7.2 (16.2.97)
*/

struct MPImage *LoadMPImage(const char *filename,struct Screen *screen,ULONG Flags);
void FreeMPImage(struct MPImage *MPi);
char *MPImageErrorMessage(void);
BOOL SaveMPImageA(const UBYTE *file,
								UBYTE *red, UBYTE *green, UBYTE *blue,
								UWORD width, UWORD height, struct TagItem *TagList);
BOOL SaveMPImage(const UBYTE *file,
								UBYTE *red, UBYTE *green, UBYTE *blue,
								UWORD width, UWORD height,Tag tag1, ...);
BOOL RescaleMPImage(struct MPImage *MPi,UWORD x,UWORD y);
void SetMPImageScreen(char *ScreenName,ULONG Flags);
void MPPlanarToChunky(struct BitMap *bitmap,UBYTE *chunky, UWORD width, UWORD height);
/* Added for Version 6.0 */
void MPProgressHook(struct Hook *Hook);
/* Added for Version 7.0 */
void MPRGBToPal(struct MPProcess *MPp,ULONG maxcol,UBYTE *pal,BOOL bit12);
void MPRToPal(struct MPProcess *MPp,ULONG maxcol,UBYTE *pal);
void MPPalToPal(UBYTE *OldPal,ULONG OldCols,UBYTE *NewPal,ULONG NewCols,
			  UBYTE *chunky,UWORD Width,UWORD Height,UWORD nPlanes,ULONG camg);
void MPPalToRGB(struct MPProcess *MPp,UBYTE *chunky,UWORD nPlanes,ULONG camg);
void MPPalToGrey(UWORD Width,UWORD Height,UBYTE *pal,UBYTE *chunky,
			UWORD nPlanes,ULONG camg,BOOL Linear);
void MPRGBToGrey(struct MPProcess *MPp,BOOL Linear);
void MPScaleRGB(struct MPProcess *Old,struct MPProcess *New,struct MPProcess *Temp);
void MPScaleGrey(UBYTE *Old,UBYTE *New,UWORD OWidth,UWORD OHeight,
				UWORD NWidth,UWORD NHeight,UBYTE *Temp);
void MPChunkyToPlanar(UBYTE *chunky,struct BitMap *bitmap,UWORD width,UWORD height);
#endif
