#include <m68881.h>
#include <math.h>
#include "crinkle.h"
#include "paint.h"

#ifndef FALSE
#	define FALSE	0
#endif
#ifndef TRUE
#	define TRUE		(! FALSE)
#endif

Fold	*top;
int		levels;
int		stop;
int		smooth;
int		cross;
int		slope;
int		snooze_time;
int		n_col;
int		band_size;
int		request_clear	= FALSE;
double	fdim;
double	mix;
double	midmix;
Height	start;							// starting value for the surface
Height	mean			= 0.0;			// mean value of surface
Height	varience;						// rough estimate of the height of the range
Height	shift;							// offset from calcalt to artist coordinates
Height	delta_shadow;					// offset of shadow at each step
double	stretch;						// vertical stretch
double	contour;
double	ambient;						// level of ambient light
double	contrast;						// contrast,
										// increases or decreases effect of cosine rule
double	vfract;							// relative strength of vertical light relative
										// to the main light source
double	altitude;
double	distance;
double	phi;							// angle of the light (vertical plane)
double	alpha;							// angle of the light (horizontal plane)
										// must have -pi/4 < alpha < pi/4
double	shadow_slip;
double	shadow_register	= 0.0;
double	cos_phi;
double	sin_phi;
double	tan_phi;
double	x_fact;
double	y_fact;
Height	sealevel;
Height	forceheight;
int		width;							// width of the landscape, (function of levels)
int		seed;							// zero means read the clock

/* -------------------------------------------------------------------- */
/* viewport parameters													*/
/* -------------------------------------------------------------------- */

int		height;							// height of the screen
double	vangle;							// view angle 0 == horizontal
										// increase to look down
double	tan_vangle;                                     
double	vscale;							// rescale physical height by this amount.
double	viewpos;						// position of viewpoint
double	viewheight;						// height of viewpoint
double	focal;							// focal length, calc to preserve aspect ratio

Height	*shadow;						// height of the shadows
Height	*a_strip, *b_strip;				// the two most recent strips
