*
*	card.a - card copy routine for REKO DataType class
*	Copyright  1995-96 Michael Letowski
*


	include	'graphics/gfx.i'

	xdef	_CopyColors
	xdef	_CopyCard

	section	text,code


*
*	VOID CopyColors(R_A0 ULONG *cRegs, R_A1 struct ColorRegister *cMap,
*			R_D0 ULONG numCols)
*

Mul3	macro					; Mul3(val,spare)
	move.l	\1,\2				; Remember value
	add.l	\1,\1				; Double value
	add.l	\2,\1				; Triple value
	endm

Color32	macro					; Color32(col,spare)
	move.b	\1,\2				; Remember 8-bit color
	lsl.l	#8,\1				; Set upper 8 bits
	move.b	\2,\1				; Set lower 8 bits
	move.w	\1,\2				; Remember 16-bit color
	swap	\1				; Set upper 16 bits
	move.w	\2,\1				; Set lower 16 bits
	endm
	
_CopyColors:
	movem.l	d1-d2,-(sp)			; Remember registers
	Mul3	d0,d2				; Multiply by 3
	subq.l	#1,d0				; Correction for dbra

ColLoop:
	move.b	(a1)+,d1			; Get red component
	Color32	d1,d2				; Convert to 32 bits
	move.l	d1,(a0)+			; Set color register
	dbra	d0,ColLoop			; Repeat
	movem.l	(sp)+,d1-d2			; Restore registers
	rts					; Return


*
*	VOID CopyCard(R_A0 struct BitMap *bm, R_A1 MPTR buffer, R_D0 ULONG num,
*			R_D1 ULONG h, R_D2 ULONG d, R_D3 ULONG lSize)

_CopyCard:
	movem.l	a2-a3/d2-d6,-(sp)		; Save registers
	bsr.b	GetXY				; d4=X, d5=Y
	moveq.l	#0,d0
	move.w	bm_BytesPerRow(a0),d0		; d0=BPR
	mulu.w	d0,d5				; d5=BPR*Y
	mulu.w	d1,d5				; d5=h*BPR*Y
	mulu.w	d3,d4				; d4=lSize*X
	add.l	d5,d4				; d4=DstOffs
	subq.l	#1,d1				; Correction for dbra
	subq.l	#1,d3				; Correction for dbra
	lea.l	bm_Planes(a0),a0		; a0=&bm->Planes[0]

HLoop:						; For each line...
	move.l	d2,d5				; d5=d
	subq.l	#1,d5				; Correction for dbra
	move.l	a0,a2				; a2=&bm->Planes[0] (a copy)
DLoop:						; For each plane...
	move.l	(a2)+,a3			; a3=bm->Planes[I]
	add.l	d4,a3				; a3=DstOffs+bm->Planes[I]
	move.l	d3,d6				; d7=lSize (a copy)
CopyLoop:					; For each byte...
	move.b	(a1)+,(a3)+			; Copy one byte
	dbra	d6,CopyLoop			; Copy all bytes
	dbra	d5,DLoop			; Next plane
	add.l	d0,d4				; d4+=BPR+DstOffs
	dbra	d1,HLoop			; Next line...

	movem.l	(sp)+,a2-a3/d2-d6		; Restore registers
	rts					; Return


*
*	VOID GetXY(R_D0 ULONG num, R_D4 ULONG *x, R_D5 ULONG *y)
*

REKOCNT	equ	68

GetXY:
	cmpi.l	#REKOCNT,d0			; num<REKO_III?
	bge.b	.Else				; No - calculate position
	moveq.l	#0,d4				; Set to 0
	move.b	XMapping(pc,d0.l),d4		; *x=XMapping[num]
	moveq.l	#0,d5				; Set to 0
	move.b	YMapping(pc,d0.l),d5		; *y=YMapping[num]
	rts

.Else:
	move.l	d0,d4				; *x=num
	asr.l	#2,d4				; *x=num/VCNT
	move.l	d0,d5				; *y=num
	andi.l	#3,d5				; *y=num%VCNT
	rts

*
*	Mapping tables
*

XMapping:
	dc.b	13,13,13
	dc.b	0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,6,6,6,6
	dc.b	7,7,7,7,8,8,8,8,9,9,9,9,10,10,10,10,11,11,11,11,12,12,12,12
	dc.b	13,14,15,16
	dc.b	14,15,16
	dc.b	14,15,16
	dc.b	14,15,16

YMapping:
	dc.b	1,2,3
	dc.b	0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3
	dc.b	0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3,0,1,2,3
	dc.b	0,0,0,0
	dc.b	1,1,1
	dc.b	2,2,2
	dc.b	3,3,3

	end
